#!/bin/bash

logging_disabled=33
LOGFILE="/var/log/myfile.log"
mkinit_name="myfile.txt";

log() {
    # don't log until we initialised logging properly
    if [ -z "$logging_disabled" ] || [ "$logging_disabled" -eq 1 ] ; then
        return
    fi
    if [ "$1" = "-n" ] || [ "$1" = "-ne" ]  ; then
        shift
        echo -en " " "$@" >> $LOGFILE
    elif [ $# -eq 0 ] ; then
        echo >> $LOGFILE
    else
        echo >> $LOGFILE
        echo -en $(date +'%Y-%m-%d %H:%M:%S') "$*" >> $LOGFILE
    fi
}


find_tmpdir()
{
    local dir st size last_size=0

    for dir in `ls -R $1`; do
        if test ! -w "$dir"; then
            continue
        fi
        # try to find a directory with at least 50MB free space
        st=`stat -f -c '%f * %S' "$dir/"`
        if test -z "$st"; then
            continue
        fi
        size=$(($st))
        if test "$size" -ge $((50 << 20)); then
            tmp_dir="$dir"
	    echo "Success "$dir
	    return
        else
	    echo "Unsuccess "$dir
	if test "$size" -gt "$last_size"; then
            tmp_dir="$dir"
            last_size="$size"
        fi
	fi
    done
    if [ ! -d "$tmp_dir" ]; then
        echo "$tmp_dir is not a directory" >&2
        exit 1
    fi
    echo "warning: using $tmp_dir with $(($last_size >> 20))MB free space" >&2
    echo "this might not be enough" >&2
}

umount_proc() {
    [ "$mounted_proc" ] && umount -n $mounted_proc
    mounted_proc=
    [ "$mounted_sys" ] && umount -n $mounted_sys
    mounted_sys=
    [ "$mounted_usr" ] && umount -v -n $mounted_usr
    mounted_usr=
}

mounted_proc=/proc
mounted_usr=/usr
mounted_sys=/sys

handle_terminate() {
    echo "(received signal) $1

Interrupted, cleaning up." >&2
    cleanup
    cleanup_finish
/home/alice/source/bash/p9.sh
    exit 255
}

trap handle_terminate 1 2 3 9 15

log "myfile is enable"
find_tmpdir $1
work_dir=$(mktemp -qd $tmp_dir/${mkinit_name}.XXXXXX)
if [ $? -ne 0 ]; then
        echo "$0: Can't create temp dir, exiting." >&2
        exit 1
./p9.sh
fi
echo "workdir "$work_dir
echo $tmp_dir//${mkinit_name}
umount_proc


